[[docker-iptables]]
[[docker-kvm]]
## docker
### 理论

物理机 > 虚拟化 > 容器化
![[Pasted image 20240620223606.png]]
![[Pasted image 20240701104733.png]]
docker就实现了这三个方面 资源隔离
![[Pasted image 20240620231236.png]]
![[Pasted image 20240620234129.png]]
### 实践
#### 配置内核流量转发
- 因为docker和宿主机的端口映射 本质上是内核的流量转发
- 配置：
```shell
 cat <<EOF >  /etc/sysctl.d/docker.conf
net.bridge.bridge-nf-call-ip6tables = 1
net.bridge.bridge-nf-call-iptables = 1
net.ipv4.ip_forward=1
EOF

加载内核防火墙模块，允许流量转发
加载内核防火墙功能参数1
modprobe br_netfilter

查看：
lsmod | grep netfilter

sysctl -p /etc/sysctl.d/docker.conf

```
![[Pasted image 20240621235054.png]]
![[Pasted image 20240621235201.png]]
就是开启转发了
#### 安装
```shell
yum remove docker docker-common docker-selinux docker-engine
yum install yum-utils device-mapper-persistent-data lvm2
#下载docker源
wget -O /etc/yum.repos.d/docker-ce.repo https://download.docker.com/linux/centos/docker-ce.repo
(可以本机下载传进去)
#更改阿里源
sed -i 's#download.docker.com#mirrors.tuna.tsinghua.edu.cn/docker-ce#g'  /etc/yum.repos.d/docker-ce.repo
#建立元数据
yum makecache fast
#安装docker-ce  社区版，免费版 docker
yum install docker-ce -y
systemctl start docker
ps -ef|grep docker
docker version
```
- 国外下载节点太慢 配置加速器
```shell
vim /etc/docker/daemon.json

{ 
    "registry-mirrors": ["https://eb7m68tc.mirror.aliyuncs.com"] 
}
systemctl daemon-reload 
systemctl restart docker
```
![[Pasted image 20240622012618.png]]

#### 启动第一个容器
```shell
1. 搜索镜像
    docker search nginx
2. 下载
     docker pull nginx
     镜像名：版本    不写版本就默认latest  最新
3. 运行
     docker run -d   -p 28877:80  nginx 
     # 端口映射，你才能访问到容器内的东西
     # -p 28877:80   将宿主机的28877流量转发给容器内目标端口80              端口（-P 随机端口 后面什么端口都不跟）
     # -d 后台运行docker实例进程
4. 查看
     docker ps
```
![[Pasted image 20240622003636.png]]
![[Pasted image 20240622003913.png]]
#### docker命令
```shell
docker search name 搜索镜像
docker pull  name   下载镜像
docker images 查看下载的镜像
docker rm (最少三位id   完整id   name ) 删除
docker stop   (最少三位id   完整id   name   )
docker start  (run是第一次 更改映射端口什么的 )
docker ps  查看正在run容器
docker ps -a 查看所有docker
docker run ---
docker rm    （要先stop）
docker rmi images 删除镜像
docker logs id
docker logs -f 
docker top id 查看容器内进程
docker stats id 查看容器占用资源情况
```
![[Pasted image 20240622161916.png]]

### 常见实践
#### 下载不同版本的nginx
![[Pasted image 20240622153902.png]]
- 基于一个镜像运行多个容器
![[Pasted image 20240622154532.png]]
![[Pasted image 20240622155016.png]]
- names都是随机的
- 自己起名字run的时候要加--name 
- ![[Pasted image 20240622155114.png]]
##### 对内访问
![[Pasted image 20240622160148.png]]
- 查看容器信息
- docker inspect id ｜ grep -i xx
- ![[Pasted image 20240701222348.png]]
- 格式化拿到ip
##### 对外访问
![[Pasted image 20240622160247.png]]
- 直接浏览器访问
#### 运行镜像，生成容器(ubuntu容器)
![[Pasted image 20240622161147.png]]
- 一个系统有内核+发行版（centos  ubuntu等）组成
- 有了容器就不用搞内核 直接下载发行版
##### 批量操作
![[Pasted image 20240622162407.png]]
- docker stop $(docker ps -q)
- docker ps -q 只显示id
##### 进入ubuntu内
![[Pasted image 20240622163631.png]]
##### 自制一个docker镜像
1. 开一个docker centos
2. 更新yum源
```shell
rm -rf /etc/yum.repos.d/* 
curl -o /etc/yum.repos.d/CentOS-Base.repo https://mirrors.aliyun.com/repo/Centos-7.repo
curl -o /etc/yum.repos.d/epel.repo https://mirrors.aliyun.com/repo/epel-7.repo 
```
##### 登陆hub.docker推送
```shell
docker login
docker tag source_image tagget_image
docker push carlzhaoxi/hello-world
```
- 删除本地镜像才能下载
- docker rmi images 删除镜像
3. yum install nginx vim net-tools -y
4. yum clean all  --exit
5. 提交容器记录，生成新的镜像记录 
   docker commit id  自己name
6. docker login
7. docker push image_name
8. 不知道为啥一直超时 推不了
##### 已经运行的容器怎么进入
`docker exec -it id bash`

- 前台运行docker 必须要前台运行宿主机才会显示docker运行
- docker run -d -p 80:80 carlzhaoxi/nginx_centos nginx -g 'daemon off;'
#### 局域网导出镜像并运行
导出有两种方式
- docker pull 提交到镜像仓库
- docker save 
![[Pasted image 20240622205108.png]]
- scp传输
另一台：
![[Pasted image 20240622211031.png]]
![[Pasted image 20240622213220.png]]
#### 下载mysql5.7.38镜像，确保可以远程访问，创建库表
![[Pasted image 20240622215007.png]]
## dockerfile
### 理论：
![[Pasted image 20240701131819.png]]
![[Pasted image 20240701150614.png]]
  - 上面错了 add会自动接呀 copy只是单纯的复制
- dockerfile实践：
- 需求：![[Pasted image 20240701133552.png]]
```shell
vim Dockerfile #固定名字

FROM nginx #如果本地有就直接用 没有就自动去pull
RUN echo 'test dockerfile' > /usr/share/nginx/html/index.html

docker build -t nginx:file .  #-t指定name和tag
docker run -d -p 80:80 nginx:file 
```
#### copy：
![[Pasted image 20240701134920.png]]
#### add：
![[Pasted image 20240701134955.png]]
#### cmd：
![[Pasted image 20240701135302.png]]
 ![[Pasted image 20240701135513.png]]
##### 半路杀出面试题：
 - entrypoint和cmd的区别
#### entrypoint：
![[Pasted image 20240701141111.png]]
- 构建一个centos发行版并curl一个gpg
![[Pasted image 20240701144303.png]]
![[Pasted image 20240701144349.png]]
- 最好使用全称➕tag 
- 后面加参数的话会直接把dockerfile里面的cmd覆盖
![[Pasted image 20240701150106.png]]
- 而entrypoint后面可以加参数一起执行  
#### workdir：
- 就是cd  workdir：cd /相当于进入容器内直接是/
#### arg：
- 设置环境变量 
- ARG NAME="zhaoxi"
#### env：
- 设置环境变量
- ENV NAME="zhaoxi"
##### 半路杀出面试题：
- 什么区别
- ![[Pasted image 20240701151130.png]]
#### volume：
- 声明 Volume 和定义挂载点
- 在 Dockerfile 中声明 VOLUME 是一种指示，告诉 Docker 容器应用可能会用到的挂载点，但它并不会自动在容器启动时创建挂载点，也不会在 `docker inspect` 命令的输出中显示。
- 定义挂载点：docker run -v /data_volume:/app/data
- 使用： VOLUME /app/data  
eg：
```shell
>Dockerfile
vim 

FROM centos:7.9.2009
MAINTAINER zhaoxi
VOLUME ["/data1","/data2"]

build > run > inspect > grep mount , volume 
```
![[Pasted image 20240701154231.png]]
- 这样子手动run定义挂载点才能在inspect看到mounts。
- ![[Pasted image 20240701154444.png]]
#### expose：
- 指定容器运行时对外提供的端口
```shell
# 定义容器监听的端口 
EXPOSE 8080
EXPOSE 8080 9000 3306

EXPOSE 8080/tcp
EXPOSE 9000/tcp
```
#### user：
```shell
user root
user carl
# 用来改变或者切换用户
```
### 实践
- docker部署python网站(项目)
1.
```shell
1.编写python文件
[root@ali_yun ~/docker_file] cat my_first_flask.py 
from flask import Flask
app = Flask(__name__)
@app.route('/hello')
def hello():
    return "hello from docker, I am zhaoxi"
if __name__ == '__main__':
    app.run(host='0.0.0.0', port=8080)

2.编写Dockerfile
From centos:7.9.2009
RUN curl -o /etc/yum.repos.d/CentOS-Base.repo https://mirrors.aliyun.com/repo/Centos-7.repo;
RUN curl -o /etc/yum.repos.d/epel.repo https://mirrors.aliyun.com/repo/epel-7.repo;
RUN yum makecache fast;
RUN yum install python3-devel python3-pip -y
RUN pip3 install -i https://mirrors.aliyun.com/pypi/simple flask
COPY my_first_flask.py /opt
WORKDIR /opt
EXPOSE 8080
CMD ["python3","my_first_flask.py"]
3.构建镜像
docker build --no-cache -t my_webflask:v1 .
# --no-cache 不使用缓存
4.运行
docker run -d -p 90:8080 --name first_flask my_webflask:v1 
5.访问
curl localhost:90/hello
hello from docker, I am zhaoxi
```
2.
![[Pasted image 20240701225304.png]]
![[Pasted image 20240701225321.png]]
```shell
docker build -t nginx:new_index .
```

## docker-compose
### 理论
#### 安装
```shell
sudo curl -L "https://github.com/docker/compose/releases/latest/download/docker-compose-$(uname -s)-$(uname -m)" -o /usr/local/bin/docker-compose

sudo chmod +x /usr/local/bin/docker-compose

docker-compose --version
```
#### 常见命令
```shell
1.docker compose up -d  #-d后台运行  创建并启动
2.docker compose ps     查看
3.docker compose down   #停止并删除  -v删除卷
4.docker compose logs   日志
5.docker compose up -d --build  重构
6.docker compose start 启动 也可以docker compose start web 启动特定服务
7.docker compose stop 停止
```
### 实践
![[Pasted image 20240701235148.png]]
```yml
services:
  web:
    image: php:7.4-apache
    container_name: web
    volumes:
      - ./html:/var/www/html
    ports:
      - "8080:80"
    networks:
      - lampnet

  db:
    image: mysql:5.7
    container_name: db
    environment:
      MYSQL_ROOT_PASSWORD: example
      MYSQL_DATABASE: exampledb
      MYSQL_USER: exampleuser
      MYSQL_PASSWORD: examplepass
    volumes:
      - db_data:/var/lib/mysql
    networks:
      - lampnet

networks:
  lampnet:

volumes:
  db_data:
```


